Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultStatement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultStatement.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultStatement.java	(revision 44738)
@@ -5,6 +5,8 @@
 import java.util.Objects;
 import org.apache.commons.lang3.ArrayUtils;
 import org.apache.commons.lang3.StringUtils;
+import org.apache.commons.lang3.tuple.ImmutablePair;
+import org.apache.commons.lang3.tuple.Pair;
 import org.gvsig.expressionevaluator.Code;
 import org.gvsig.expressionevaluator.Code.Caller;
 import org.gvsig.expressionevaluator.Codes;
@@ -18,6 +20,7 @@
 import org.gvsig.expressionevaluator.Statement.StatementContext;
 import org.gvsig.expressionevaluator.impl.function.programming.CodeBlockFunction;
 import org.gvsig.expressionevaluator.impl.DefaultCodeBuilder.BaseCodes;
+import org.gvsig.expressionevaluator.spi.AbstractLexicalAnalyzer;
 
 /**
  *
@@ -31,12 +34,16 @@
 //    private String codeId;
 //    private ArgsBuilder argsBuilder;
 
+    public interface IsApplicableRule extends Rule {
+      public boolean isApplicable(StatementContext context);
+    }
+    
     public interface RepeatRule extends CompoundRule {
 
         public String getClassifier();
     }
 
-    public class RuleRequireAnyToken implements Rule {
+    public class RuleRequireAnyToken implements IsApplicableRule {
 
         private final String[] required_token;
 
@@ -46,6 +53,7 @@
 
         @Override
         public void parse(StatementContext context) {
+            context.trace(this.toString()+".parse");
             Token token = context.look_token();
             if (!token.is(this.required_token)) {
                 throw new ExpressionSyntaxException(
@@ -59,9 +67,12 @@
             context.next_token();
         }
 
-        private boolean isApplicable(StatementContext context) {
-            Token token = context.look_token();
-            return token.is(this.required_token);
+        @Override
+        public boolean isApplicable(StatementContext context) {
+            Token token = context.next_token();
+            boolean r = token.is(this.required_token);
+            context.trace(this.toString()+".isApplicable return "+r);
+            return r;
         }
 
         @Override
@@ -71,7 +82,7 @@
 
     }
 
-    public class RuleRequireIdentifier implements Rule {
+    public class RuleRequireIdentifier implements IsApplicableRule {
 
         private final String id;
 
@@ -81,6 +92,7 @@
 
         @Override
         public void parse(StatementContext context) {
+            context.trace(this.toString()+".parse");
             Token token = context.look_token();
             if (token.getType() != Token.IDENTIFIER) {
                 throw new ExpressionSyntaxException(
@@ -95,6 +107,14 @@
         }
 
         @Override
+        public boolean isApplicable(StatementContext context) {
+            Token token = context.next_token();
+            boolean r = token.getType() == Token.IDENTIFIER;
+            context.trace(this.toString()+".isApplicable return "+r);
+            return r;
+        }
+        
+        @Override
         public String toString() {
             return "require_identifier('" + this.id + "')";
         }
@@ -110,6 +130,7 @@
 
         @Override
         public void parse(StatementContext context) {
+            context.trace(this.toString()+".parse");
             Token token = context.look_token();
             if (token.getType() != Token.STRING_LITERAL) {
                 throw new ExpressionSyntaxException(
@@ -139,6 +160,7 @@
 
         @Override
         public void parse(StatementContext context) {
+            context.trace(this.toString()+".parse");
             Code code = context.parse_expression();
             if (code == null) {
                 throw new ExpressionSyntaxException(context.getLexicalAnalyzer());
@@ -165,6 +187,7 @@
 
         @Override
         public void parse(StatementContext context) {
+            context.trace(this.toString()+".parse");
             if( this.value instanceof Code ) {
                 context.setCode(id, (Code) this.value);
             } else {
@@ -190,6 +213,7 @@
 
         @Override
         public void parse(StatementContext context) {
+            context.trace(this.toString()+".parse");
             Codes codes = context.parse_expressions(this.separator);
             if (codes == null) {
                 throw new ExpressionSyntaxException(context.getLexicalAnalyzer());
@@ -259,6 +283,7 @@
 
         @Override
         public void parse(StatementContext context) {
+            context.trace(this.toString()+".parse");
             Token token = context.look_token();
             if (token.is(this.optional_token)) {
                 context.next_token();
@@ -286,10 +311,57 @@
 
         @Override
         public String toString() {
-            return "optional_token(" + StringUtils.join(this.optional_token) + ") rules:" + StringUtils.join(onTrueRules, ",");
+            return "optional_token(" + StringUtils.join(this.optional_token) + ") onTrue:" + StringUtils.join(onTrueRules, ",")+", onFalse:" + StringUtils.join(onFalseRules, ",");
         }
     }
 
+    public class RuleSwitchToken implements SwichTokenRule {
+
+        private final List<Pair<String,Rule[]>> caseRules;
+        private Rule[] defaultRule;
+
+        public RuleSwitchToken() {
+            this.caseRules = new ArrayList<>();
+        }
+
+        @Override
+        public void parse(StatementContext context) {
+            context.trace(this.toString()+".parse");
+            Token token = context.look_token();
+            for (Pair<String, Rule[]> caseRule : caseRules) {
+              if( token.is(caseRule.getKey()) ) {
+                context.next_token();
+                for (Rule rule : caseRule.getValue()) {
+                  rule.parse(context);
+                }
+                return;
+              }
+            }
+            if( defaultRule!=null ) {
+              for (Rule rule : defaultRule) {
+                rule.parse(context);
+              }
+            }
+        }
+
+        @Override
+        public SwichTokenRule addCase(String token, Rule... rules) {
+            this.caseRules.add(new ImmutablePair(token,rules));
+            return this;
+        }
+
+        @Override
+        public SwichTokenRule addDefault(Rule... rules) {
+            this.defaultRule = rules;
+            return this;
+        }
+
+        @Override
+        public String toString() {
+            return "switch_token() rules:" + StringUtils.join(this.caseRules,",") + " default: " + defaultRule;
+        }
+    }
+
     public class RuleRepeatUntilAnyTokens implements RepeatRule {
 
         private final String[] exit_tokens;
@@ -303,6 +375,7 @@
 
         @Override
         public void parse(StatementContext context) {
+            context.trace(this.toString()+".parse");
             String save = context.getCodeClassifier();
             try {
                 this.counter = 1;
@@ -340,6 +413,78 @@
         }
     }
 
+    public class RuleRepeat implements RepeatRule {
+
+        private final List<Rule> rules;
+        private int counter;
+
+        public RuleRepeat() {
+            this.rules = new ArrayList<>();
+        }
+
+        @Override
+        public void parse(StatementContext context) {
+            context.trace(this.toString()+".parse");
+            String save = context.getCodeClassifier();
+            try {
+                this.counter = 1;
+                boolean breakloop = false;
+                while (!breakloop) {
+                    context.setCodeClassifier(String.valueOf(counter).trim());
+                    for (Rule rule : rules) {
+                      try {
+                        rule.parse(context);
+                      } catch(BreakLoopException ex) {
+                        breakloop = true;
+                        break;
+                      }
+                    }
+                    this.counter = this.counter + 1;
+                }
+            } finally {
+                context.setCodeClassifier(save);
+            }
+        }
+
+        @Override
+        public RuleRepeat addRule(Rule rule) {
+            this.rules.add(rule);
+            return this;
+        }
+
+        @Override
+        public String getClassifier() {
+            String s = String.valueOf(counter).trim();
+            return s;
+        }
+
+        @Override
+        public String toString() {
+            return "repeat() rules:" + StringUtils.join(rules, ",");
+        }
+    }
+
+    public static class BreakLoopException extends RuntimeException {
+      
+    }
+    
+    public static class RuleBreakLoop implements Rule {
+
+        public RuleBreakLoop() {
+        }
+
+        @Override
+        public void parse(StatementContext context) {
+          context.trace(this.toString()+".parse");
+          throw new BreakLoopException();
+        }
+
+        @Override
+        public String toString() {
+            return "break_loop()";
+        }
+    }
+
     public class RuleOptionalIdentifiers extends AbstractConditionalRule implements ConditionalRule {
 
         private final String id;
@@ -353,6 +498,7 @@
 
         @Override
         public void parse(StatementContext context) {
+            context.trace(this.toString()+".parse");
             BaseCodes args = (BaseCodes) context.getCodeBuilder().args();
             Token token = context.look_token();
             while (token.getType() == Token.IDENTIFIER) {
@@ -396,6 +542,7 @@
 
         @Override
         public void parse(StatementContext context) {
+            context.trace(this.toString()+".parse");
             Token token = context.look_token();
             if (token.getType() == Token.STRING_LITERAL) {
                 String s = (String) token.getValue();
@@ -416,14 +563,20 @@
 
     public static class ArgsBuilderFromNames implements ArgsBuilder {
 
-        private final String[] argNames;
+        protected final String[] argNames;
 
         public ArgsBuilderFromNames(String... argNames) {
             this.argNames = argNames;
         }
 
         @Override
+        public String toString() {
+          return "args_names("+StringUtils.join(argNames,",")+")";
+        }
+        
+        @Override
         public Codes build(StatementContext context) {
+            context.trace(this.toString()+".build");
             BaseCodes args = (BaseCodes) context.getCodeBuilder().args();
             for (String argName : argNames) {
                 if (argName.contains("#")) {
@@ -434,7 +587,7 @@
                         if (code == null) {
                             break;
                         }
-                        args.add(code);
+                        args.add(argNameX, code);
                         n++;
                     }
                 } else {
@@ -442,7 +595,7 @@
 //                    if( code == null) {
 //                        code = context.getCodeBuilder().constant(null);
 //                    }
-                    args.add(code);
+                    args.add(argName,code);
                 }
             }
             return args;
@@ -456,6 +609,11 @@
         }
 
         @Override
+        public String toString() {
+          return "args_expand("+StringUtils.join(argNames,",")+")";
+        }
+        
+        @Override
         public Codes build(StatementContext context) {
             BaseCodes args = (BaseCodes) context.getCodeBuilder().args();
             
@@ -595,11 +753,25 @@
         if (this.rules.isEmpty()) {
             return false;
         }
-        Rule rule = this.rules.get(0);
-        if (!(rule instanceof RuleRequireAnyToken)) {
-            return false;
+        context.trace(this.getName()+".isApplicable");
+        AbstractLexicalAnalyzer lexer = (AbstractLexicalAnalyzer) context.getLexicalAnalyzer();
+        lexer.push_state();
+        try {
+          boolean applicable = false;
+          for (Rule rule : rules) {
+            if (!(rule instanceof IsApplicableRule)) {
+                break;
+            }
+            if( !((IsApplicableRule) rule).isApplicable(context) ) {
+              return false;
+            }
+            applicable = true;
+          }
+          context.trace(this.getName()+".isApplicable return "+applicable);
+          return applicable;
+        } finally {
+          lexer.pop_state();
         }
-        return ((RuleRequireAnyToken) rule).isApplicable(context);
     }
 
     @Override
@@ -619,17 +791,19 @@
         this.builder(new StatementBuilderBase(id, argsBuilder));
     }
 
+    @Override
     public void builder(StatementBuilder builder) {
         this.stmtBuilder = builder;
     }
     
     @Override
     public Code parse(StatementContext context) {
-//        System.err.println("start parse "+this.getName());
+        context.trace(this.getName()+".parse");
         for (Rule rule : rules) {
             rule.parse(context);
         }
         Code code = this.stmtBuilder.build(context);
+        context.trace(this.getName()+".return "+code);
         return code;
     }
 
@@ -638,4 +812,20 @@
         return this.getName() + " " + StringUtils.join(this.rules, ";");
 
     }
+
+    @Override
+    public CompoundRule repeat() {
+      return new RuleRepeat();
+    }
+
+    @Override
+    public Rule break_loop() {
+      return new RuleBreakLoop();
+    }
+    
+    @Override
+    public SwichTokenRule switch_token() {
+      return new RuleSwitchToken();
+    }
+
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultExpressionEvaluatorSwingManager.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultExpressionEvaluatorSwingManager.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultExpressionEvaluatorSwingManager.java	(revision 44738)
@@ -60,7 +60,7 @@
         
         for (SymbolTable symbolTable : symbolTables) {
             for (Function function : symbolTable.functions()) {
-                if( isAllowed == null || isAllowed.test(function) ) {
+                if( !function.isHidden() && isAllowed != null && isAllowed.test(function) ) {
                   functions.put(function.name().toUpperCase(), function);
                 }
             }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.time/org.gvsig.expressionevaluator.time.lib/org.gvsig.expressionevaluator.time.lib.impl/src/main/resources/META-INF/services/org.gvsig.tools.library.Library
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.time/org.gvsig.expressionevaluator.time.lib/org.gvsig.expressionevaluator.time.lib.impl/src/main/resources/META-INF/services/org.gvsig.tools.library.Library	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.time/org.gvsig.expressionevaluator.time.lib/org.gvsig.expressionevaluator.time.lib.impl/src/main/resources/META-INF/services/org.gvsig.tools.library.Library	(revision 44738)
@@ -1 +1 @@
-org.gvsig.expressionevaluator.impl.GeometryExpressionEvaluatorImplLibrary
\ No newline at end of file
+org.gvsig.expressionevaluator.impl.TimeExpressionEvaluatorImplLibrary
\ No newline at end of file
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/resources/org/gvsig/fmap/dal/swing/impl/searchpanel/.directory
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/resources/org/gvsig/fmap/dal/swing/impl/searchpanel/.directory	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/resources/org/gvsig/fmap/dal/swing/impl/searchpanel/.directory	(revision 44738)
@@ -0,0 +1,4 @@
+[Dolphin]
+Timestamp=2020,2,2,10,33,14
+Version=4
+ViewMode=1
